<template>
  <div class="block-form ui form ">
    <div class="subtitle">
      {{ title }}
    </div>

    <div class="three fields">
      <div
        class="field"
        :class="{ invalid: validation.hasError('name') }">
        <label>Название
          <span v-if="displayType === 'sto'">центра</span>
          <span v-if="displayType === 'shop'">магазина</span>
          <span class="red">*</span>
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.name,
            }"/>
          </div>
        </label>
        <div class="ui input ">
          <input
            type="text"
            v-model="name"
          >
        </div>
        <div
          class="error message"
          v-if="validation.hasError('name')">
          {{ validation.firstError('name') }}
        </div>
      </div>

      <div
        v-if="displayType === 'shop'"
        class="field"
        :class="{ invalid: validation.hasError('shopAttributes') }">
        <label>Сфера деятельности
          <span class="red">*</span>
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.activity,
            }"/>
          </div>
        </label>
        <multiselect
          class="no-tags"
          v-model="shopAttributes"
          :options="shopAttributesOptions"
          :disabled="!shopAttributesOptions.length"
          label="name"
          track-by="id"
          id="selectActivity"
          :searchable="false"
          :show-labels="false"
          :preselect-first="false"
          :multiple="true"
          :close-on-select="false"
          :clear-on-select="false"
          placeholder="Выберите">
          <template
            slot="selection"
            slot-scope="{ values, search, isOpen }">
            <span
              class="multiselect__single"
              v-if="shopAttributes.length && !isOpen">Выбрано ({{ shopAttributes.length }})
            </span>
          </template>
        </multiselect>
        <div
          class="error message activity"
          v-if="validation.hasError('shopAttributes')">
          {{ validation.firstError('shopAttributes') }}
        </div>
        <div class="warning message activity">
          <ul class="list selection-result">
            <li
              v-for="(item, index) in shopAttributes"
              :key="index"
              class="item">{{ item.name }}</li>
          </ul>
        </div>
      </div>
    </div>

    <div class="three fields">
      <div
        class="field "
        :class="{ invalid: validation.hasError('organization') }">
        <label>Организация <span class="red">*</span></label>
        <multiselect
          v-model="organization"
          class="no-checkbox no-tags"
          :options="organizationOptions"
          :disabled="!organizationOptions.length"
          label="name"
          track-by="id"
          id="selectOrg"
          :allow-empty="false"
          :searchable="false"
          :show-labels="false"
          :preselect-first="false"
          placeholder="Выберите"/>
        <div
          class="error message"
          v-if="validation.hasError('organization')">
          {{ validation.firstError('organization') }}
        </div>
      </div>
    </div>

    <add-phone
      :type="displayType"
      :additional-information-request="additionalInformationRequest"
      :hint="hintContent.default"
      :is-send="hasSendRequest"
      v-model="phones"/>

    <div class="three fields">
      <div
        class="field _width-55"
        :class="{ invalid: validation.hasError('email') }">
        <label>E-mail <span class="red">*</span>
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.default,
            }"/>
          </div>
        </label>
        <div class="ui input">
          <input
            v-model="email"
            type="text">
          <div class="input_options">
            <button
              class="ui button blue small"
              :class="{ disabled: hasDisabledEmailConfirmButton }"
              v-tooltip.ios="emailButtonTooltip('Подтверждение возможно только после сохранения изменений')"
              @click="confirmEmail()">
              {{ emailIsConfirmed ? 'Подтверждено' : 'Подтвердить' }}
            </button>
            <div
              v-show="emailIsConfirmed && !entityEmail.hasChange"
              v-tooltip.ios="entityConfirmTooltip('Контакт подтвержден')"
              class="entity-confirmed">
              <img
                svg-inline
                src="~/assets/svg/icons/confirmed.svg"
                alt="иконка подтверждения">
            </div>
            <div
              v-show="!isUniqueEmail"
              v-tooltip.ios="emailTooltip"
              class="entity-information _alert">
              <img
                svg-inline
                src="~/assets/svg/icons/info.svg"
                alt="иконка информации">
            </div>
          </div>
        </div>
        <div
          class="error message"
          v-if="validation.hasError('email')">
          {{ validation.firstError('email') }}
        </div>
      </div>
    </div>

    <div class="three fields">
      <div
        class="field _width-55"
        :class="{ invalid: error }">
        <label>Сайт&nbsp;
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.default,
            }"/>
          </div>
        </label>
        <div class="ui input ">
          <input
            v-model="site"
            type="text">
          <div class="input_options">
            <div
              v-show="siteIsConfirmed && !entitySite.hasChange"
              v-tooltip.ios="entityConfirmTooltip('Сайт подтвержден')"
              class="entity-confirmed">
              <img
                svg-inline
                src="~/assets/svg/icons/confirmed.svg"
                alt="иконка подтверждения">
            </div>
            <div
              v-show="!siteIsConfirmed || entitySite.hasChange"
              v-tooltip.ios="entityConfirmTooltip(entityConfirmContent(entitySite))"
              class="entity-confirmed">
              <img
                svg-inline
                src="~/assets/svg/icons/info.svg"
                alt="иконка информации">
            </div>
          </div>
        </div>
        <div
          class="error message"
          v-if="error">
          {{ error }}
        </div>
      </div>
    </div>

    <add-connection
      v-model="values.connections"
      :aditional-contacts="aditionalContacts"
      :display-type="displayType"
      :additional-contact-methods-options="additionalContactMethodsOptions"
      :is-send="hasSendRequest"
      @change-additional-contact="changeAdditionalContact"
      @has-error="onAdditionalContactHasError"/>

    <hr class="separator ">

    <div class="subtitle _flex ">
      Адрес и расположение на карте&nbsp;
      <div class="question">
        <div
          class="button"
          v-tooltip="{
            classes: 'tooltip kit white',
            trigger: 'hover',
            offset: '4',
            placement: 'right',
            html: 'true',
            content: hintContent.addressSto,
        }"/>
      </div>
      <div class="input_options">
        <div
          v-show="addressIsConfirmed && !entityAddress.hasChange"
          v-tooltip.ios="entityConfirmTooltip('Адрес подтвержден')"
          class="entity-confirmed">
          <img
            svg-inline
            src="~/assets/svg/icons/confirmed.svg"
            alt="иконка подтверждения">
        </div>
        <div
          v-show="!addressIsConfirmed || entityAddress.hasChange"
          v-tooltip.ios="entityConfirmTooltip(entityConfirmContent(entityAddress))"
          class="entity-confirmed">
          <img
            svg-inline
            src="~/assets/svg/icons/info.svg"
            alt="иконка информации">
        </div>
      </div>
    </div>

    <div class="three fields">
      <div class="field map">
        <map-frame
          :address="address"
          :position="marker"
          @set-coordinates="setCoordinates"
          @set-address="setAddress"/>
      </div>
      <div class="field address">
        <label>Адрес&nbsp;<span class="red">*</span>&nbsp;
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.address,
            }"/>
          </div>
        </label>
        <div
          class="field"
          :class="{ invalid: validation.hasError('city') }">
          <city-search
            :value="city"
            @input="selectCity"
          />
          <div
            class="error message"
            v-if="validation.hasError('city')">
            {{ validation.firstError('city') }}
          </div>
        </div>
        <div
          class="field"
          style="padding-top: 14px">
          <multiselect
            class="no-checkbox"
            label="name"
            track-by="id"
            id="subways"
            v-model="subway"
            :options="subways"
            :disabled="!subways || !subways.length"
            :loading="isSubwaysLoading"
            :searchable="false"
            :show-labels="false"
            :preselect-first="false"
            :close-on-select="true"
            :clear-on-select="false"
            placeholder="Укажите ближайшую станцию метро">
            <template
              slot="clear"
              v-if="subway">
              <div
                class="multiselect__clear"
                @mousedown.prevent.stop="clearSubway(null, 'carManufacturer')"/>
            </template>
          </multiselect>
        </div>
        <div
          class="field"
          :class="{ invalid: validation.hasError('street') }">
          <div class="ui input street">
            <input
              v-model="street"
              type="text"
              placeholder="Улица">
          </div>
          <div
            class="error message address"
            v-if="validation.hasError('street')">
            {{ validation.firstError('street') }}
          </div>
        </div>
        <div class="flexline">
          <div
            class="field house"
            :class="{ invalid: validation.hasError('building') }">
            <div class="ui input">
              <input
                v-model="building"
                type="text"
                :disabled="!street"
                placeholder="Дом/Корпус">
            </div>
          </div>
          <div class="ui input office">
            <input
              v-model="office"
              type="text"
              placeholder="№ офиса">
          </div>
        </div>
        <div
          class="error message address"
          v-if="validation.hasError('building')">
          {{ validation.firstError('building') }}
        </div>

        <label>
          Координаты на карте
        </label>
        <div
          class="field"
          :class="{ invalid: error }">
          <span
            v-if="!coordLon && !coordLat"
            class="location">
            Не указано
          </span>
          <ul class="coordinates">
            <li class="coordinate"> Долгота: {{ coordLon }}</li>
            <li class="coordinate"> Широта: {{ coordLat }}</li>
          </ul>
          <div
            class="error message"
            v-if="error">
            {{ error }}
          </div>
        </div>

      </div>
    </div>

    <hr class="separator ">

    <div class="subtitle _flex">Режим работы&nbsp;
      <div class="question">
        <div
          class="button"
          v-tooltip="{
            classes: 'tooltip kit white',
            trigger: 'hover',
            offset: '4',
            placement: 'right',
            html: 'true',
            content: hintContent.default,
        }"/>
      </div>
      <div class="input_options">
        <div
          v-show="scheduleIsConfirmed && !entitySchedule.hasChange"
          v-tooltip.ios="entityConfirmTooltip('Режим работы подтвержден')"
          class="entity-confirmed">
          <img
            svg-inline
            src="~/assets/svg/icons/confirmed.svg"
            alt="иконка подтверждения">
        </div>
        <div
          v-show="!scheduleIsConfirmed || entitySchedule.hasChange"
          v-tooltip.ios="entityConfirmTooltip(entityConfirmContent(entityAddress))"
          class="entity-confirmed">
          <img
            svg-inline
            src="~/assets/svg/icons/info.svg"
            alt="иконка информации">
        </div>
      </div>
    </div>
    <div
      class="error message error-schedule invalid"
      v-if="validation.hasError('schedules')">
      Проверьте правильность заполненных полей.
    </div>
    <set-schedule
      v-model="schedules"
      :initial-schedules="information.shopSchedule || information.schedules"
      @input="onChangeSchedule"/>

    <hr class="separator">

    <div class="subtitle">Дополнительные сведения</div>

    <div
      v-if="isSTO"
      class="three fields">
      <div class="field">
        <label>Запчасти&nbsp;<span class="red">*</span>&nbsp;
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.parts,
            }"/>
          </div>
        </label>
        <div>
          <div class="ui radio checkbox">
            <input
              id="sparesTrue"
              v-model="spares"
              :value="true"
              type="radio"
              name="addInfoParts">
            <label for="sparesTrue">Есть</label>
          </div>
        </div>
        <div class="ui radio checkbox">
          <input
            id="sparesFalse"
            :value="false"
            v-model="spares"
            type="radio"
            name="addInfoParts">
          <label for="sparesFalse">Не предусмотрено</label>
        </div>
      </div>
      <div
        class="field"
        :class="{ invalid: validation.hasError('hourPriceMin') || validation.hasError('hourPriceMax') }">
        <label>Нормо-час&nbsp;<span class="red">*</span>&nbsp;
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.hourPrice,
            }"/>
          </div>
        </label>
        <div class="flexline">
          <div class="ui input range">
            <input
              v-model="hourPriceMin"
              type="text"
              placeholder="от">
          </div>
          <div class="divider">-</div>
          <div class="ui input range">
            <input
              v-model="hourPriceMax"
              type="text"
              placeholder="до">
          </div>
        </div>
        <div
          class="error message"
          v-if="validation.hasError('hourPriceMin') || validation.hasError('hourPriceMax')">
          {{ validation.firstError('hourPriceMin') || validation.firstError('hourPriceMax') }}
        </div>
      </div>
    </div>

    <div class="three fields ">
      <div class="field">
        <label>Способы оплаты&nbsp;
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.paymentMethods,
            }"/>
          </div>
        </label>
        <multiselect
          class="no-tags"
          v-model="paymentMethods"
          :options="paymentMethodsOptions"
          label="name"
          track-by="id"
          id="paymentMethods"
          :searchable="false"
          :show-labels="false"
          :preselect-first="false"
          :multiple="true"
          :close-on-select="false"
          :clear-on-select="false"
          placeholder="Выберите">
          <template
            slot="selection"
            slot-scope="{ values, search, isOpen }">
            <span
              class="multiselect__single"
              v-if="paymentMethods.length && !isOpen">Выбрано ({{ paymentMethods.length }})
            </span>
          </template>
        </multiselect>
        <div class="warning message">
          <!--          <ul class="list selection-result">-->
          <!--            <li-->
          <!--              v-for="(item, index) in paymentMethods"-->
          <!--              :key="index"-->
          <!--              class="item">{{ item.name }}</li>-->
          <!--          </ul>-->
        </div>
      </div>
      <div
        v-if="displayType === 'sto'"
        class="field">
        <label>Предоставляемые услуги&nbsp;
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.services,
            }"/>
          </div>
        </label>
        <button
          @click="showModalByType('listServices')"
          type="button"
          class="kit btn false select">
          {{ getMultiselectFieldState('services') }}
        </button>
      </div>
      <div
        v-if="displayType === 'shop'"
        class="field">
        <label>Официальный дилер&nbsp;
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.officialMarks,
            }"/>
          </div>
        </label>
        <button
          @click="showModalByType('officialMarks')"
          type="button"
          class="kit btn false select">
          {{ getMultiselectFieldState('officialMarks') }}
        </button>
      </div>
    </div>

    <div class="three fields">
      <div class="field">
        <label>Дополнительная информация &nbsp;
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.info,
            }"/>
          </div>
        </label>
        <div class="ui input">
          <textarea
            v-model="additionalInfo"
            class="small"/>
        </div>
      </div>

      <div
        v-if="displayType === 'shop'"
        class="field">
        <label>Продаваемые марки&nbsp;
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.repairMarks,
            }"/>
          </div>
        </label>
        <button
          @click="showModalByType('tradingManufacturers')"
          type="button"
          class="kit btn false select">
          {{ getMultiselectFieldState('tradingManufacturers') }}
        </button>
        <div class="warning message">
          <!--          <ul class="list selection-result">-->
          <!--            <li-->
          <!--              v-for="(item, index) in tradingManufacturers"-->
          <!--              :key="index"-->
          <!--              class="item">{{ item.brand }}</li>-->
          <!--          </ul>-->
        </div>
      </div>

      <div
        v-if="displayType==='sto'"
        class="field">
        <label>Ремонтируемые марки&nbsp;
          <div class="question">
            <div
              class="button"
              v-tooltip="{
                classes: 'tooltip kit white',
                trigger: 'hover',
                offset: '4',
                placement: 'right',
                html: 'true',
                content: hintContent.brands,
            }"/>
          </div>
        </label>
        <button
          @click="showModalByType('repairedManufacturers')"
          type="button"
          class="kit btn false select">
          {{ getMultiselectFieldState('brands') }}
        </button>
      </div>
    </div>
    <div
      v-if="displayType === 'sto'"
      class="fluid">
      <hr class="separator">
      <div class="subtitle">Настройка входящих запросов</div>
      <div class="three fields">
        <div class="field">
          <label>Предоставляемые услуги&nbsp;
            <div class="question">
              <div
                class="button"
                v-tooltip="{
                  classes: 'tooltip kit white',
                  trigger: 'hover',
                  offset: '4',
                  placement: 'right',
                  html: 'true',
                  content: hintContent.services,
              }"/>
            </div>
          </label>
          <button
            @click="showModalByType('taskListServices')"
            type="button"
            class="kit btn false select">
            {{ getMultiselectFieldState('taskServices') }}
          </button>
          <div class="ui checkbox inbox">
            <input
              type="checkbox"
              name=""
              v-model="nonSpecifiedServiceGroup"
              id="nonSpecifiedServiceGroup"
              checked>
            <label for="nonSpecifiedServiceGroup">
              Получать запросы без специализации&nbsp;
              <div class="question">
                <div
                  class="button"
                  v-tooltip="{
                    classes: 'tooltip kit white',
                    trigger: 'hover',
                    offset: '4',
                    placement: 'right',
                    html: 'true',
                    content: hintContent.inbox,
                }"/>
              </div>
            </label>
          </div>
        </div>
        <div class="field">
          <label>Ремонтируемые марки&nbsp;
            <div class="question">
              <div
                class="button"
                v-tooltip="{
                  classes: 'tooltip kit white',
                  trigger: 'hover',
                  offset: '4',
                  placement: 'right',
                  html: 'true',
                  content: hintContent.brands,
              }"/>
            </div>
          </label>
          <button
            @click="showModalByType('repairedManufacturersInbox')"
            type="button"
            class="kit btn false select">
            {{ getMultiselectFieldState('taskBrands') }}
          </button>
          <div class="ui checkbox inbox">
            <input
              v-model="sendNotification"
              type="checkbox"
              name=""
              id="sendNotifications"
              checked>
            <label for="sendNotifications">Отправлять уведомления о входящих запросах на почту</label>
          </div>
        </div>
      </div>
    </div>
    <hr class="separator">

    <template v-if="isStore">
      <div class="subtitle _flex">
        Перенаправление на сайт магазина&nbsp;
        <div class="question">
          <div
            class="button"
            v-tooltip="{
              classes: 'tooltip kit white',
              trigger: 'hover',
              offset: '4',
              placement: 'right',
              html: 'true',
              content: hintContent.extUrl,
          }"/>
        </div>
      </div>

      <div class="subtitle warn">Функционал временно недоступен</div>

      <div class="three fields">
        <div
          class="field wide disabled"
        >
          <div class="ui checkbox">
            <input
              type="checkbox"
              name="extUrlItemRedirect"
              id="extUrlItemRedirect"
              v-model="extUrlItemRedirect">
            <label for="extUrlItemRedirect">
              Включить перенаправление по названию запчасти
            </label>
          </div>
        </div>
      </div>

      <div class="three fields">
        <div class="field wide disabled">
          <div class="ui checkbox">
            <input
              type="checkbox"
              name="extUrlOrderRedirect"
              id="extUrlOrderRedirect"
              v-model="extUrlOrderRedirect">
            <label for="extUrlOrderRedirect">
              Включить перенаправление по нажатию на кнопку "Перейти в магазин"
            </label>
          </div>
        </div>
      </div>

      <div class="three fields">
        <div
          class="field widest disabled"
          :class="{
            invalid: isExtUrlEnabled && validation.hasError('extUrlItemUrl'),
        }">
          <label>
            Укажите ссылку, по которой покупатели перейдут на ваш сайт
            (страница с товаром, предложением, любая другая)
            <span class="red">*</span>
          </label>
          <div class="ui input">
            <input
              type="text"
              v-model="extUrlItemUrl">
          </div>
          <div
            class="error message"
            v-if="isExtUrlEnabled && validation.hasError('extUrlItemUrl')">
            {{ validation.firstError('extUrlItemUrl') }}
          </div>
        </div>
      </div>

      <div class="three fields ext-url-notes">
        <div
          class="field widest disabled">
          <label>
            Чтобы каждая ссылка вела на конкретный товар, замените в ней следующие значения (если они есть):
          </label>
          <label class="sublabel">
            Например, для ссылки
            <i>https://xxx.ru/?pbrandname=<b>Denso</b>&amp;pbrandnumber=<b>DUR065L</b>&amp;source=wipers_catalog</i>
            замените:
          </label>
          <div class="flexline _stretch">
            <div class="col">
              <ul>
                <li><b>Denso</b> &ndash;> <b>{brand}</b></li>
                <li><b>DUR065L</b> &ndash;> <b>{vendor_code}</b></li>
              </ul>
              <label class="sublabel">
                для ссылки
                <i>https://xxx.ru/poisk/<b>denso</b>/<b>dcri107730</b>/c_<b>novosibirsk</b></i>:
              </label>
              <ul>
                <li><b>denso</b> &ndash;> <b>{brand}</b></li>
                <li><b>dcri107730</b> &ndash;> <b>{vendor_code}</b></li>
                <li><b>novosibirsk</b> &ndash;> <b>{city}</b></li>
              </ul>
            </div>
            <div class="col attention">
              <img
                svg-inline
                src="~/assets/svg/redesign/attention.svg">
              Важно! Если написание бренда на вашем сайте отличается от нашего, то ссылка работать не будет!
            </div>
          </div>
        </div>
      </div>

      <div
        v-if="extUrlExample"
        class="three fields">
        <div
          class="field widest disabled">
          <label>Проверьте вашу ссылку</label>
          <label class="sublabel">Например, такой будет ссылка для свечи зажигания NGK 6240 в Новосибирске:</label>
          <label>
            <a
              :href="extUrlExample"
              target="_blank"
              rel="nofollow">
              {{ extUrlExample }}
            </a>
          </label>
        </div>
      </div>

      <hr class="separator">
    </template>

    <div>
      <div class="chat-wrapper">
        <div class="chat-note">Для получения консультации по настройке напишите в чат</div>
        <TechSupportChat/>
      </div>

      <button
        type="submit"
        @click="send"
        class="ui button yellow">
        <span>
          {{ saveButtonText }}
        </span>
      </button>
    </div>

    <brands
      v-if="displayType === 'shop'"
      v-model="modals.tradingManufacturers"
      :current-selected-manufacturers="tradingManufacturers"
      :car-manufacturers="carManufacturersList"
      :type="'tradingManufacturers'"
      @set-trading-manufacturers="setTradingManufacturers"/>

    <brands
      v-if="displayType === 'shop'"
      v-model="modals.officialMarks"
      :current-selected-manufacturers="officialMarks"
      :car-manufacturers="carManufacturersList"
      :type="'officialMarks'"
      @set-trading-manufacturers="setOfficialMarks"/>

    <brands
      v-if="displayType === 'sto'"
      v-model="modals.repairedManufacturers"
      :current-selected-manufacturers="brands"
      :car-manufacturers="carManufacturersList"
      :type="'repairedManufacturers'"
      @set-trading-manufacturers="setRepairedManufacturers"/>

    <brands
      v-if="displayType === 'sto'"
      v-model="modals.repairedManufacturersInbox"
      :current-selected-manufacturers="taskBrands"
      :car-manufacturers="carManufacturersList"
      :type="'repairedManufacturersInbox'"
      @set-trading-manufacturers="setRepairedManufacturersInbox"/>

    <list-services
      v-if="displayType === 'sto'"
      v-model="modals.listServices"
      :list-services="listService"
      :current-selected-list-services="services"
      :type="'listServices'"
      @set-services="setServices"/>

    <list-services
      v-if="displayType === 'sto'"
      v-model="modals.taskListServices"
      :list-services="listService"
      :current-selected-list-services="taskServices"
      :type="'taskListServices'"
      @set-services="setTaskServices"/>
    <VerifyMail
      v-model="entityEmail.confirmModal"
      @input="confirmVerifyCode($event)"
      @sendAgain="confirmEmail"
      @close="closeEmailVerify"
      :error-message="entityEmail.verifyError"/>
  </div>
</template>

<script>
import Vue from 'vue';
import { createNamespacedHelpers } from 'vuex';
import Multiselect from 'vue-multiselect';
import SimpleVueValidation from 'simple-vue-validator';
import {
  has,
  get,
  isEmpty,
  uniqBy,
  debounce,
} from 'lodash-es';
import { SHOW } from '~/assets/js/store/infoModal/action-types';
import Shop from '~/assets/js/model/organization/shop';
import Sto from '~/assets/js/model/organization/sto';
import { GeoLevel } from '~/backend/api-bundle/graphql/types';

import MapFrame from '~/components/redesign/blocks/map';
import SetSchedule from '~/components/redesign/cabinet/set-schedule';
import AddPhone from '~/components/redesign/cabinet/add-phone';
import AddConnection from '~/components/redesign/cabinet/add-connection';
import CitySearch from '~/components/redesign/blocks/citySearch';
import TechSupportChat from '~/components/redesign/blocks/tech-support-chat';
import Brands from '~/components/redesign/cabinet/modal/brands';
import VerifyMail from '~/components/redesign/cabinet/modal/verify-mail';
import ListServices from '~/components/redesign/cabinet/modal/list-services';
import Validator from '~/assets/js/validator';

import dayjs from 'dayjs';
import customParseFormat from 'dayjs/plugin/customParseFormat';
import isSameOrAfter from 'dayjs/plugin/isSameOrAfter';
import isBetween from 'dayjs/plugin/isBetween';

dayjs.extend(customParseFormat);
dayjs.extend(isSameOrAfter);
dayjs.extend(isBetween);

const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');

const SimpleVueValidator = SimpleVueValidation.Validator;

Vue.use(SimpleVueValidation, {
  mode: 'conservative',
});
const ONLINE_STORE_ID = '13';

export default {
  name: 'FormStoShop',
  components: {
    AddPhone,
    AddConnection,
    SetSchedule,
    CitySearch,
    TechSupportChat,
    Multiselect,
    Brands,
    ListServices,
    MapFrame,
    VerifyMail,
  },
  mixins: [SimpleVueValidation.mixin],
  props: {
    displayType: {
      type: String,
      default: '',
    },
    actionType: {
      type: String,
      default: '',
    },
    information: {
      type: Object,
      default() { return {}; },
    },
    shopAttributesOptions: {
      type: Array,
      default() { return []; },
    },
    paymentMethodsOptions: {
      type: Array,
      default() { return []; },
    },
    additionalContactMethodsOptions: {
      type: Array,
      default() { return []; },
    },
    listService: {
      type: Array,
      default() { return []; },
    },
    carManufacturersList: {
      type: Object,
      default() { return {}; },
    },
    auth: {
      type: Object,
      default() { return {}; },
    },
    location: {
      type: Object,
      default() { return {}; },
    },
  },
  data() {
    const data = this.displayType === 'shop'
      ? new Shop(this.information)
      : new Sto(this.information);

    if (data && !data.city) {
      data.city = this.getDefaultCity();
    }

    const additionalInformationRequest = {};

    if (this.displayType === 'shop') {
      additionalInformationRequest.shopId = Number(data.id);
    } else {
      additionalInformationRequest.stoId = Number(data.id);
    }

    return {
      error: false,
      isValid: true,
      // TODO: Что это такое? Почему такой naming?
      values: {
        connections: [],
      },
      schedules: [],
      convertedSchedules: [],
      ...data,
      notValidConnections: [],
      address: '',
      /* eslint-disable max-len */
      hintContent: {
        name: '<div class=help-cabinet><p>Отображается в поле "Продавец" в результате поиска запчасти.</p></div>',
        default: '<div class=help-cabinet><p>Данные, которые доступны покупателям для связи с Вами, отображаются в поле "Продавец" в&nbsp;результате поиска запчасти для конкретного магазина/автотехцентра.</p></div>',
        activity: '<div class=help-cabinet><p>Укажите сферы деятельности, которыми вы занимаетесь. Отображается в поле "О&nbsp;продавце".</p></div>',
        parts: '<div class=help-cabinet><p>Если ваш сервис снимает с клиента заботы по самостоятельному приобретению запчастей для ремонта, выберите пункт&nbsp;"Есть".</p></div>',
        hourPrice: '<div class=help-cabinet><p>Укажите диапазон стоимости нормо-часа для ваших клиентов.</p></div>',
        addressSto: '<div class=help-cabinet><p>Укажите адрес магазина/автотехцентра на карте</p></div>',
        address: '<div class=help-cabinet><p>Данные, которые доступны покупателям, отображаются в поле "Продавец" в результате поиска запчасти для конкретного магазина/автотехцентра. А&nbsp;также, отображаются на карте при условии нажатия кнопки "Найти на карте".</p></div>',
        paymentMethods: '<div class=help-cabinet><p>Укажите способы оплаты приемлемые для Вашего магазина/автотехцентра. Отображается в поле "О&nbsp;продавце".</p></div>',
        info: '<div class=help-cabinet><p>Укажите ту информацию, которую, как Вы считаете, должны знать покупатели о Вашем магазине, не более 300 символов.</p></div>',
        services: '<div class=help-cabinet><p>Выберите предоставляемые услуги.</p></div>',
        brands: '<div class=help-cabinet><p>Выберите ремонтируемые марки.</p></div>',
        repairMarks: '<div class=help-cabinet><p>Укажите марки автомобилей, которые Вы продаёте. Отображается в поле "О&nbsp;продавце".</p></div>',
        officialMarks: '<div class=help-cabinet><p>Если Ваша организация является официальным дилером, укажите марки этих автомобилей. Отображается в поле "О&nbsp;продавце".</p></div>',
        tradingMarks: '<div class=help-cabinet><p>Если Ваша организация является официальным дилером, укажите марки автомобилей, которые Вы продаёте. Отображается в поле "О&nbsp;продавце".</p></div>',
        inbox: '<div class=help-cabinet><p>Выбрав данную опцию вы будете получать <b>больше</b> запросов. Вам будут также приходить запросы от клиентов, не указавших желаемую специализацию автотехцентра.</p></div>',
        extUrl: '<div class=help-cabinet><p>Заинтересованные покупатели смогут перейти на ваш сайт по названию запчасти или по кнопке "Перейти в магазин".</p></div>',
      },
      /* eslint-enable max-len */
      modals: {
        tradingManufacturers: false,
        officialMarks: false,
        repairedManufacturers: false,
        repairedManufacturersInbox: false,
        listServices: false,
        taskListServices: false,
      },
      subways: [],
      subway: this.information.metro ? {
        id: this.information.metro.id,
        name: this.information.metro.name,
      } : null,
      isSubwaysLoading: false,
      additionalInformationRequest,
      hasSendRequest: false,
      entityEmail: {
        confirmModal: false,
        verifyError: '',
        hasChange: false,
      },
      entitySite: {
        hasChange: false,
      },
      entityAddress: {
        hasChange: false,
      },
      entitySchedule: {
        hasChange: false,
      },
      isUniqueEmail: true,
      emailTooltip: {
        classes: 'ui popup tooltip visible dark bottom',
        placement: 'right',
        trigger: 'hover',
        offset: '12',
        html: 'true',
        content: `<div style='text-align: center'>
                    Свяжитесь с вашим менеджером или по телефону ${this.$config.contacts.info.phone}
                  </div>`,
      },
    };
  },
  computed: {
    title() {
      return `Основные сведения ${this.displayType === 'shop' ? 'о магазине' : 'об автотехцентре'}`;
    },
    saveButtonText() {
      return `${this.actionType === 'new'
        ? 'Создать'
        : 'Сохранить'} ${this.displayType === 'sto'
        ? 'автотехцентр'
        : 'магазин'}`;
    },
    getAddress() {
      const address = [];

      (this.city && this.city.parent && this.city.parent.name) && address.push(this.city.parent.name);
      (this.city && this.city.name) && address.push(this.city.name);
      this.street && address.push(this.street);
      this.building && address.push(this.building);
      this.office && address.push(this.office);

      return address.join(',');
    },
    marker() {
      const marker = {
        lat: 0,
        lng: 0,
      };

      if (this.coordLat && this.coordLon) {
        marker.lat = this.coordLat;
        marker.lng = this.coordLon;
        return marker;
      }

      return {
        location: this.location && this.location.name,
      };
    },
    isOnlineStore() {
      return this.shopAttributes
        && this.shopAttributes.length
        && this.shopAttributes.some(shopAttribute => shopAttribute.id === ONLINE_STORE_ID);
    },
    isStore() {
      return this.displayType === 'shop';
    },
    isSTO() {
      return this.displayType === 'sto';
    },
    isEditAction() {
      return this.actionType === 'edit';
    },
    connections() {
      return this.values.connections;
    },
    hasDisabledEmailConfirmButton() {
      return this.emailIsConfirmed || this.entityEmail.hasChange;
    },
    isExtUrlEnabled() {
      return this.extUrlItemRedirect || this.extUrlOrderRedirect;
    },
    extUrlExample() {
      if (!this.extUrlItemUrl) {
        return null;
      }
      return this.extUrlItemUrl
        .replace('{brand}', 'ngk')
        .replace('{vendor_code}', '6240')
        .replace('{city}', 'novosibirsk');
    },
  },
  validators: {
    name(value) {
      return SimpleVueValidator
        .value(value)
        .custom(() => {
          if (isEmpty(value)) {
            return 'Поле обязательно к заполнению.';
          }
          return false;
        });
    },
    shopAttributes(value) {
      return SimpleVueValidator
        .value(value)
        .custom(() => (this.isStore && !value.length) && 'Поле обязательно к заполнению.');
    },
    organization(value) {
      return SimpleVueValidator
        .value(value)
        .custom(() => {
          if (!Object.keys(value).length) {
            return 'Поле обязательно к заполнению.';
          }
          return false;
        });
    },
    email(value) {
      return SimpleVueValidator
        .value(value)
        .custom(() => {
          if (isEmpty(value)) {
            return 'Укажите E-mail.';
          }

          if (value && !Validator.checkEmail(value)) {
            return 'Введите корректный E-mail';
          }

          if (!this.isUniqueEmail) {
            return 'E-mail уже используется';
          }

          return false;
        });
    },
    city(value) {
      return SimpleVueValidator
        .value(value)
        .custom(() => (!value || !value.id) && 'Поле обязательно к заполнению.');
    },
    street(value) {
      return SimpleVueValidator
        .value(value)
        .custom(() => !value && !this.isOnlineStore && 'Поле обязательно к заполнению.');
    },
    building(value) {
      return SimpleVueValidator
        .value(value)
        .custom(() => (this.street && !value) && !this.isOnlineStore && 'Поле обязательно к заполнению.');
    },
    // @todo Вынести валидацию в компонент set-schedule
    // Упростить валидацию, сейчас очень сложно понимать что твориться
    schedules(value) {
      return SimpleVueValidator
        .value(value)
        .custom(() => {
          this.convertedSchedules = this.convertSchedulesToSend();

          const invalidDays = this.convertedSchedules
            .filter((day) => {
              const openBegin = dayjs(day.scheduleOpeningTime, 'HH:mm');
              const openEnd = dayjs(day.scheduleClosingTime, 'HH:mm');
              const dinnerBegin = dayjs(day.scheduleDinnerBegin, 'HH:mm');
              const dinnerEnd = dayjs(day.scheduleDinnerEnd, 'HH:mm');
              let dayInvalid = false;

              // Обед должен входить в промежуток времени работы
              if (
                day.scheduleOpeningTime
                  && day.scheduleClosingTime
                  && day.scheduleDinnerBegin
                  && day.scheduleDinnerEnd
              ) {
                if (openEnd.isBefore(openBegin)) {
                  openEnd.add(1, 'day');
                }

                // Время начала обеда меньше и не равно времени окончания
                if (dinnerBegin.isSameOrAfter(dinnerEnd)) {
                  dayInvalid = true;
                } else {
                  // '[' означает включение, '(' означает исключение
                  dayInvalid = !dinnerBegin.isBetween(openBegin, openEnd, null, '(')
                    || !dinnerEnd.isBetween(openBegin, openEnd, null, '(');
                }
              }
              return dayInvalid;
            });
          return Boolean(invalidDays.length);
        });
    },
    'hourPriceMin, hourPriceMax'(hourPriceMin, hourPriceMax) {
      return SimpleVueValidator.value(hourPriceMin, hourPriceMax).custom(() => {
        if (this.isSTO && (hourPriceMin.length > 6 || hourPriceMax.length > 6)) {
          return 'Некорректное значение поля';
        }

        if (this.isSTO && Number(hourPriceMin) > Number(hourPriceMax)) {
          return 'Минимальное значение не может быть больше максимального';
        }

        if (this.isSTO && (!hourPriceMin || !hourPriceMax)) {
          return 'Поле обязательно к заполнению.';
        }

        return false;
      });
    },
    extUrlItemUrl(value) {
      return SimpleVueValidator.value(value).custom(() => {
        if (!this.isStore || !this.isExtUrlEnabled) {
          return false;
        }
        if (!value) {
          return 'Пожалуйста, вставьте ссылку';
        }
        if (!value.match(/^http(s)?:\/\//)) {
          return 'Ссылка должна начинатся с http:// или https://';
        }
        return false;
      });
    },
  },
  watch: {
    'city.id'() {
      this.resetAddressConfirmState();
    },
    street(newValue) {
      this.$validate('street');
      this.address = this.getAddress;
      this.resetAddressConfirmState();

      if (newValue === '') {
        this.building = '';
      }
    },
    building() {
      this.address = this.getAddress;
      this.resetAddressConfirmState();
    },
    email(newValue) {
      if (newValue) {
        this.emailIsConfirmed = false;
        this.entityEmail.hasChange = true;
        this.debouncedCheckUniqueEmail();
      }
    },
    site(newValue) {
      if (newValue) {
        this.siteIsConfirmed = false;
        this.entitySite.hasChange = true;
      }
    },
    isOnlineStore() {
      this.$validate('building');
      this.$validate('street');
    },
    isUniqueEmail() {
      this.$validate('email');
    },
  },
  created() {
    this.debouncedCheckUniqueEmail = debounce(this.checkUniqueEmail, 500);
  },
  mounted() {
    this.loadSubwaysList();
    this.address = this.getAddress;
  },
  methods: {
    ...STORE_INFO_MODAL.mapActions({
      showInfo: SHOW,
    }),
    async send() {
      // TODO: Срочно нужен другой валидатор и кросс-валидация между компонентами.
      // TODO: Нужен метод типа allowSendRequest чтобы убрать всю логику валидации в себя
      this.hasSendRequest = true;
      this.isValid = !this.phones.some(phone => !phone.isValid)
        && !this.values.connections.some(connection => connection.error)
        && await this.$validate();

      if (!this.isValid) {
        try {
          // TODO: Как лучше установить фокус на первое обязательное поле? Жесткий workaround
          setTimeout(() => {
            const invalidInput = document.querySelectorAll('.invalid')[0];

            if (invalidInput) {
              window.scrollTo(0, invalidInput.offsetTop);
            }
          }, 0);
        } catch (e) {
          console.error(e);
        }

        this.showInfo({
          text: 'Заполните обязательные поля',
          buttonVisible: false,
        });

        return;
      }

      const url = this.getUrlForSendRequest();

      const data = this.isStore
        ? Object.assign({}, this.getRequestData(), this.createRequestShopData())
        : Object.assign({}, this.getRequestData(), this.createRequestStoData());

      try {
        await this.$axios.$post(`/_main/${url}`, data);
        this.$router.push({ path: '/cabinet/wrench/organization-sto/' });
      } catch (e) {
        this.hasSendRequest = false;
        this.isValid = false;
        this.showInfo({
          text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
          buttonVisible: false,
        });
        console.error(e);
      }
    },
    showModalByType(type) {
      if (has(this.modals, type)) {
        this.modals[type] = true;
      }
    },
    getDefaultCity() {
      const city = {};

      if (this.location && this.location.name && this.location.id && this.location.level === GeoLevel.City) {
        city.id = this.location.id;
        city.name = this.location.name;
      }

      return city;
    },
    setCoordinates(coordinates) {
      this.coordLat = get(coordinates, 'lat', '');
      this.coordLon = get(coordinates, 'lng', '');
    },
    setTradingManufacturers(tradingManufacturers) {
      if (tradingManufacturers) {
        this.tradingManufacturers = tradingManufacturers;
      }
    },
    setOfficialMarks(officialMarks) {
      if (officialMarks) {
        this.officialMarks = officialMarks;
      }
    },
    setRepairedManufacturers(repairedManufacturers) {
      if (repairedManufacturers) {
        this.brands = repairedManufacturers;
      }
    },
    setRepairedManufacturersInbox(repairedManufacturersInbox) {
      if (repairedManufacturersInbox) {
        this.taskBrands = repairedManufacturersInbox;
      }
    },
    setServices(serviceGroups) {
      this.services = uniqBy([...this.services, ...serviceGroups.service], 'id');
      this.serviceGroups = uniqBy([...this.serviceGroups, ...serviceGroups.serviceGroups], 'id');
    },
    setTaskServices(serviceGroups) {
      this.taskServices = uniqBy([...this.taskServices, ...serviceGroups.service], 'id');
      this.taskServiceGroups = uniqBy([...this.taskServiceGroups, ...serviceGroups.serviceGroups], 'id');
    },
    getMultiselectFieldState(field) {
      return field && this[field] && this[field].length
        ? `Выбрано ${this[field].length}`
        : 'Выберите';
    },
    selectCity(city) {
      if (city) {
        this.city = city;
        this.address = this.getAddress;
        this.loadSubwaysList();
        this.subway = null;
      }
    },
    setAddress(address) {
      this.address = address;
    },
    async loadSubwaysList() {
      const cityId = this.city && this.city.id;
      if (!cityId) {
        return;
      }

      this.isSubwaysLoading = true;

      try {
        const { data } = await this.$axios.$get('/_main/geo/get', {
          params: { level: GeoLevel.Metro, parentId: cityId },
        });

        if (data) {
          this.subways = data;
        }
      } catch (error) {
        console.error(error);
      } finally {
        this.isSubwaysLoading = false;
      }
    },
    clearSubway() {
      this.subway = null;
    },
    getItemId(items) {
      return (items && items.length)
        ? items.map(item => (Number(item.id)))
        : [];
    },
    getUrlForSendRequest() {
      let url = '';

      url += this.isStore ? 'shop' : 'sto';
      url += this.isEditAction ? '/update' : '/create';

      return url;
    },
    convertSchedulesToSend() {
      const week = ['пн', 'вт', 'ср', 'чт', 'пт', 'сб', 'вс'];

      return this.schedules
        .filter(schedule => schedule.days && schedule.days.length)
        .reduce((acc, schedule) => {
          const hour = schedule.hour;
          const lunch = schedule.lunch;
          const hasHours = Boolean(hour.enabled && hour.begin && hour.end);
          const hasLunch = Boolean(lunch.enabled && lunch.begin && lunch.end);

          acc = [
            ...acc,
            ...schedule.days
              .filter(day => week.includes(day))
              .map(day => ({
                scheduleDayNumber: week.indexOf(day) + 1, // отправлять дни недели с индексами от 1 до 7
                scheduleOpeningTime: hasHours ? hour.begin : '',
                scheduleClosingTime: hasHours ? hour.end : '',
                scheduleDinnerBegin: hasLunch ? lunch.begin : '',
                scheduleDinnerEnd: hasLunch ? lunch.end : '',
              })),
          ];

          return acc;
        }, []);
    },
    getRequestData() {
      // TODO: Вынести на уровень сущность phone
      const phones = this.phones
        ? this.phones
          .filter(phone => phone.model.phone)
          .map(phone => ({
            phoneId: Number(phone.model.id) || Number(phone.model.phoneId) || null,
            phoneValue: phone.model.phone,
            phoneComment: phone.model.comment || '',
            phonePosition: phone.model.position || 0,
          }))
        : [];

      // TODO: Регулярки так же вынести. Улучшить читаемость
      const contactsStandart = this.values.connections.map((obj, index) => {
        const contact = {};
        let totalValue = obj.name;
        contact.contactTypeId = Number(obj.type.id);

        if (obj.type && obj.type.name) {
          if (obj.type.name === 'Viber' || obj.type.name === 'WhatsApp') {
            totalValue = totalValue.replace(/\s|-|\(|\)|\+/gi, '').toLowerCase();
          } else if (obj.type.name === 'Telegram') {
            totalValue.replace(/\+|@|\s/gi, '').toLowerCase();
          }
        }

        contact.contactValue = totalValue;
        contact.contactId = Number(obj.contactId) || null;

        if (this.displayType === 'sto') contact.contactPosition = index;
        return contact;
      });

      return {
        stoId: Number(this.$route.params.id),
        shopId: Number(this.$route.params.id),
        city: this.city,
        metroId: (this.subway && this.subway.id)
          ? Number(this.subway.id)
          : null,
        paymentMethods: this.getItemId(this.paymentMethods),
        shopAttributes: this.getItemId(this.shopAttributes),
        organizationId: Number(this.auth.organization.id),
        legalId: Number(this.organization.id),
        shopName: this.name,
        stoName: this.name,
        email: this.email,
        office: this.office,
        phones,
        spares: this.spares,
        coordLat: this.coordLat,
        coordLon: this.coordLon,
        hourPriceMin: Number(this.hourPriceMin),
        hourPriceMax: Number(this.hourPriceMax),
        site: this.site || '',
        street: this.street,
        building: this.building,
        additionalInfo: this.additionalInfo,
        contacts: contactsStandart,
        // @todo вынести конвертацию в компонент set-schedule
        schedules: this.convertedSchedules,
      };
    },
    createRequestStoData() {
      return {
        brands: this.getItemId(this.brands),
        taskBrands: this.getItemId(this.taskBrands),
        nonSpecifiedServiceGroup: this.nonSpecifiedServiceGroup,
        sendNotification: this.sendNotification,
        service: this.getItemId(this.services),
        serviceGroup: this.getItemId(this.serviceGroups),
        taskService: this.getItemId(this.taskServices),
        serviceGroupTask: this.getItemId(this.taskServiceGroups),
      };
    },
    createRequestShopData() {
      return {
        tradingMarks: this.getItemId(this.tradingManufacturers),
        officialMarks: this.getItemId(this.officialMarks),
        itemRedirect: this.extUrlItemRedirect,
        orderRedirect: this.extUrlOrderRedirect,
        itemUrl: this.extUrlItemUrl,
      };
    },
    changeAdditionalContact({ value, index }) {
      if (this.values && !isEmpty(this.values.connections) && this.values.connections[index]) {
        this.values.connections[index].hasChange = true;
        this.values.connections[index].name = value || this.values.connections[index].name;
        this.values.connections[index].additionalContactIsConfirmed = false;
      }
    },
    onAdditionalContactHasError({ error, index }) {
      if (this.values && !isEmpty(this.values.connections) && this.values.connections[index]) {
        this.values.connections = this.values.connections.map((connection, i) => {
          if (index === i) {
            connection.error = error;
          }

          return connection;
        });
      }
    },
    async confirmEmail() {
      this.entityEmail.verifyError = '';

      if (this.validation.hasError('email') || this.hasDisabledEmailConfirmButton) {
        return;
      }

      try {
        const hasSuccess = await this.requestToConfirmEmail();

        hasSuccess && this.showEmailVerify();
      } catch (error) {
        console.error(error);
      }
    },
    async requestToConfirmEmail() {
      try {
        const { data } = await this.$axios
          .$post(`/_main/${this.displayType}/sendEmailToConfirm`, this.getRequestConfirmPayloadByType());

        return get(data, 'success', false);
      } catch (error) {
        if (!this.entityEmail.confirmModal) {
          this.showInfo({
            text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
            buttonVisible: false,
          });
        } else {
          this.entityEmail.verifyError = get(error, 'response.data.message', '');
        }

        console.error(error.response.data.message);
        return false;
      }
    },
    async confirmVerifyCode(code) {
      const payload = Object.assign({}, this.getRequestConfirmPayloadByType(), { code });

      try {
        const { data } = await this.$axios.$post(`/_main/${this.displayType}/emailConfirm`, payload);

        if (data && data.success) {
          this.entityEmail.confirmModal = false;
          this.emailIsConfirmed = true;
        }
      } catch (error) {
        if (error.response.status === 500) {
          this.entityEmail.confirmModal = false;
          this.showInfo({
            text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
            buttonVisible: false,
          });
          return;
        }

        this.entityEmail.verifyError = get(error, 'response.data.message', '');
        console.error(error.response.data.message);
      }
    },
    showEmailVerify() {
      this.entityEmail.confirmModal = true;
    },
    closeEmailVerify() {
      this.entityEmail.confirmModal = false;
      this.entityEmail.verifyError = '';
    },
    factoryTooltip() {
      return {
        classes: 'ui popup tooltip visible dark bottom',
        placement: 'right',
        trigger: 'hover',
        offset: '12',
        html: 'true',
      };
    },
    entityConfirmTooltip(content) {
      const tooltip = Object.assign({}, this.factoryTooltip());
      tooltip.content = `<div style='text-align: center'>${content}</div>`;
      return tooltip;
    },
    emailButtonTooltip(content) {
      if (this.email && !this.entityEmail.hasChange) {
        return null;
      }

      const tooltip = Object.assign({}, this.factoryTooltip());
      tooltip.content = `<div style='text-align: center'>${content}</div>`;
      return !this.emailIsConfirmed ? tooltip : null;
    },
    entityConfirmContent(entity) {
      return entity && entity.hasChange
        ? 'Подтверждение возможно только после сохранения изменений'
        : `Подтверждение возможно через вашего менеджера или по телефону ${this.$config.contacts.info.phone}`;
    },
    getRequestConfirmPayloadByType() {
      return this.isStore
        ? { shopId: Number(this.id) || null }
        : { stoId: Number(this.id) || null };
    },
    onChangeSchedule(value) {
      if (value) {
        this.scheduleIsConfirmed = false;
        this.entitySchedule.hasChange = true;
      }
    },
    resetAddressConfirmState() {
      this.addressIsConfirmed = false;
      this.entityAddress.hasChange = true;
    },
    checkUniqueEmail() {
      if (!Validator.checkEmail(this.email)) {
        return false;
      }

      return this.$axios
        .$get('/_main/user/checkUniqueEmail', {
          params: { email: this.email },
        })
        .then(({ data }) => {
          this.isUniqueEmail = data;
        })
        .catch(e => console.error(e));
    },
  },
};
</script>

<style lang="scss">
  .no-tags {
    .multiselect__tags-wrap {
      display: none;
    }
  }

  .field.connection {
    align-items: flex-start;
  }
</style>

<style scoped lang="scss">
  .question {
    @media screen and (max-width: 980px) {
      display: none;
    }
    @media screen and (min-width: 981px) {
      position: relative;
      display: inline-flex;
      > .button {
        display: inline-flex;
        justify-content: center;
        align-items: center;
        width: 1rem;
        height: 1rem;
        background: transparent;
        border: 1px solid #9badb9;
        border-radius: 50%;
        outline: 0;
        cursor: pointer;
        &:before {
          display: inline-flex;
          content: "?";
          font-size: 0.75rem;
          font-weight: normal;
          line-height: 1;
          color: #4272a4;
        }
      }
    }
  }

  .separator {
    display: block;
    width: 100%;
    height: 1px;
    margin-top: 20px;
    margin-bottom: 20px;
    border: none;
    border-bottom: 1px solid #9badb9;
  }

  .flexline {
    display: flex;
    flex-flow: row nowrap;
    justify-content: space-between;
    align-items: center;
    &._stretch {
      align-items: stretch;
    }
    .ui.input.range {
      width: calc((100% - 1rem) / 2) !important;
    }
    .divider {
      display: block;
      font-size: 1rem;
      padding: 0 0.5rem;
    }

    .col {
      width: 75%;

      &.attention {
        display: flex;
        align-items: flex-start;
        margin-right: -30%;
        padding: 1rem;
        width: 55%;
        font-size: 0.8125rem;
        font-weight: 500;
        line-height: 1.2;
        border-left: 1px solid #9badb9;

        .svg {
          flex-shrink: 0;
          margin-top: 0.25rem;
          margin-right: 1rem;
          width: 1.5rem;
          height: auto;
        }
      }
    }
  }

  .subtitle {
    display: block;
    width: 100%;
    line-height: 1.3;
    font-weight: 500;
    padding: 0 0 1rem 0;
    font-size: 0.875rem;
    &.details {
      padding-top: 1rem;
    }

    &._flex {
      display: flex;
      align-items: center;
    }
    &.warn {
      color: #e13c3c;
      font-size: 0.8125rem;
    }
  }

  .button-delete {
    flex: 1 0 2rem;
    display: block;
    width: 2rem;
    height: 2rem;
    outline: none;
    border: none;
    box-shadow: none;
    border-radius: 0.25rem;
    background-color: #728896;
    background-position: center;
    background-repeat: no-repeat;
    background-size: 0.8125rem auto;
    background-image: url('data:image/svg+xml;base64,PD94bWwgdmVyc2lvbj0iMS4wIiBlbmNvZGluZz0idXRmLTgiPz4KPHN2ZyBjbGFzcz0ic3ZnLWZpbGwiIGZpbGw9IiNmZmZmZmYiIHhtbG5zPSJodHRwOi8vd3d3LnczLm9yZy8yMDAwL3N2ZyIgeG1sbnM6eGxpbms9Imh0dHA6Ly93d3cudzMub3JnLzE5OTkveGxpbmsiIHg9IjBweCIgeT0iMHB4IgoJIHZpZXdCb3g9IjAgMCAxMiAxNCIgc3R5bGU9ImVuYWJsZS1iYWNrZ3JvdW5kOm5ldyAwIDAgMTIgMTQ7IiB4bWw6c3BhY2U9InByZXNlcnZlIj4KCjxyZWN0IHg9IjciIHk9IjUiIHdpZHRoPSIxIiBoZWlnaHQ9IjYiLz4KPHJlY3QgeD0iNCIgeT0iNSIgd2lkdGg9IjEiIGhlaWdodD0iNiIvPgo8cGF0aCBkPSJNMTIsMkg4LjVWMS41QzguNiwwLjcsOCwwLjEsNy4yLDBINC44QzQsMC4xLDMuNCwwLjcsMy41LDEuNVYySDB2MWgxdjguNUMxLDEyLjksMi4xLDE0LDMuNSwxNAoJaDVjMS40LDAsMi41LTEuMSwyLjUtMi41VjNoMVYyeiBNNC41LDEuNUM0LjUsMS4yLDQuNywxLDQuOCwxaDIuNGMwLjEsMCwwLjMsMC4yLDAuMywwLjVWMmgtM1YxLjV6IE0xMCwxMS41YzAsMC44LTAuNywxLjUtMS41LDEuNQoJaC01QzIuNywxMywyLDEyLjMsMiwxMS41VjNoOFYxMS41eiIvPgo8L3N2Zz4K');
    cursor: pointer;
    transition: 0.1s ease background-color;
    &:hover {
      background-color: #345A81;
    }
  }

  .list.selection-result {
    display: block;
    width: 100%;
    margin: 0;
    padding: 0;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    font-size: 0.6875rem;
    line-height: 1.5;
    font-weight: 400;
    color: #9badb9;
    > .item {
      display: inline-block;
      font: inherit;
      color: inherit;
      &:not(:first-child):before {
        content: '•';
        display: inline-block;
        padding: 0 0.25rem;
      }
    }
  }

  .ui.button.add-info {
    margin-top: 0.5rem;
  }

  .ui.button[type="submit"] {
    margin-top: 1rem;
    font-size: 0.875rem;
  }

  .ui.checkbox.inbox {
    margin-top: 0.5rem !important;
  }

  .block-btn {
    display: block;
    width: 100%;
    padding: 1.5rem 0;
    .btn-add-organization {
      display: inline-flex;
      justify-content: center;
      align-items: center;
      margin: 0;
      font-size: 0.875rem;
      + .btn-add-organization {
        margin-left: 1.5rem;
      }
      .svg-fill {
        height: 1.25rem;
        width: auto;
        margin: 0 0.5rem 0 -0.5rem;
        fill: #272727;
      }
    }
  }

  .block-form {
    display: flex;
    flex-flow: row wrap;
    justify-content: flex-start;
    align-items: stretch;
    width: 60rem;
    padding-top: 1.5rem;
    &.ui.form .field > label {
      margin: 0.25rem 0 0.375rem 0;
    }
    .fields,
    .fluid {
      width: 100%;
      label > span:not(.red) {
        color: inherit;
      }
    }
    .fields > .fields {
      margin: 0;
    }
    .message.activity {
      margin-bottom: -1.75rem;
    }
    .field.communication {
      display: flex;
      flex-flow: row nowrap;
      padding-top: 0.5rem;
      .ui.input, .multiselect {
        width: calc((100% - 2rem - 1.75rem) / 2);
        margin-right: 0.875rem;
      }
    }
    .field.address {
      .location {
        display: block;
        font-size: 0.8125rem;
        font-weight: 400;
        padding-left: 1rem;
      }
      .error.message.address {
        margin-bottom: 1rem;
        margin-top: -1rem;
      }
      .house {
        width: 60%;
      }
      .ui.input {
        margin-bottom: 1rem;
        &.street {
          width: 100%;
          margin-top: 1rem;
        }

        &.office {
          width: calc(40% - 0.875rem);
          margin-left: 0.875rem;
        }
      }
    }
    .field.map {
      width: 66.666666% !important;
    }
    .map-wrapper {
      display: block;
      width: 100%;
      height: 18.75rem;
      background-color: #ededed;
    }
  }

  .coordinates {
    padding-left: 17px;
    margin-top: 0;
    list-style: none;
    font-size: 12px;
  }

  .chat-wrapper {
    display: flex;
    align-items: center;
    .chat-note {
      font-size: 0.8125rem;
    }
  }

  .error.message.final {
    margin-top: .5rem;
  }

  .error-schedule {
    padding: 0 0 1em 0;
  }

  .ui.form .three.fields > .field,
  .ui.form .three.fields > .fields {
    width: 40% !important;
  }

  .ui.form .three.fields > .field._width-55 {
    width: 58% !important;

    & input {
      min-width: 370px;
      max-width: 370px;
    }
  }

  .ui.form .three.fields > .field.wide {
    width: 58% !important;
  }

  .ui.form .three.fields > .field.widest {
    width: 80% !important;
  }

  .ui.form .three.fields .field.map {
    width: 66.666666% !important;
  }
  .ui.form .ui.input > textarea {
    overflow: auto;
    white-space: normal;
  }

  .input_options {
    display: flex;
    align-items: center;
    justify-content: flex-end;
    padding-left: 14px;
    padding-right: 0;
  }

  .entity-confirmed {
    display: flex;

    & > svg {
      width: 24px;
      height: 25px;
      fill: #669ED9;
    }
  }

  .entity-information._alert {
    height: 25px;

    & > svg {
      width: 24px;
      height: 25px;
      fill: #e13c3c;
    }
  }

  .ui.button.blue.small {
    margin-right: 9px;

    &.disabled {
      pointer-events: auto!important;

      &:hover {
        color: #fff;
        background-color: #4272a4;
      }
    }
  }

  .fields.ext-url-notes {
    margin-top: 1rem;
    ul {
      font-size: 0.8125rem;
    }
  }

  .ui.form .field label.sublabel {
    font-weight: normal;
  }
</style>
